module SMap = Map.Make (struct type t=string let compare=compare end)

type 'a loc = { raw : 'a; 
		file : string;
		line : int;
		st_pos : int;
		end_pos : int
	      }

type ident = string loc

let id_pattern = "Patterns"
let id_spe = "_"

type symTbl =
    { symbols	: (ident * int) SMap.t;
      vars	: (ident * int) SMap.t
    }

type term =
  | T of ident * term list
  | VarSpe of ident

type guard = ident * ident

type rule =
  | Simple of term * term
  | Guarded of term * term * guard list

type rules = rule list

type trs = ident * rules

type automaton =
    { states	: ident list;
      f_states	: ident list;
      prior	: rules;
      rules	: rules
    }

type set =
  | Auto of ident * automaton
  | Set of ident * term list


type approx = unit

(* Abstract Syntactic Tree : *)
type t = symTbl * trs list * set list

let new_env s v = {symbols = s; vars = v}
