type bool = True | False
type nat = O | S of nat
type 'a option = Some of 'a | None
type ('a, 'b) prod = Pair of 'a * 'b
val fst : ('a, 'b) prod -> 'a
val snd : ('a, 'b) prod -> 'b
type comparison = Eq | Lt | Gt
type 'a sig0 = 'a
type sumbool = Left | Right
type 'a list = Nil | Cons of 'a * 'a list
val length : 'a list -> nat
val app : 'a list -> 'a list -> 'a list
val in_dec : ('a -> 'b -> sumbool) -> 'b -> 'a list -> sumbool
module Coq__1 : sig val map : ('a -> 'b) -> 'a list -> 'b list end
val map : ('a -> 'b) -> 'a list -> 'b list
val fold_left : ('a -> 'b -> 'a) -> 'b list -> 'a -> 'a
val existsb : ('a -> bool) -> 'a list -> bool
val forallb : ('a -> bool) -> 'a list -> bool
val filter : ('a -> bool) -> 'a list -> 'a list
type positive = XI of positive | XO of positive | XH
val pcompare : positive -> positive -> comparison -> comparison
val peq : positive -> positive -> sumbool
val peq0 : positive -> positive -> sumbool
val list_prod : ('a -> 'b -> 'c) -> 'a list -> 'b list -> 'c list
val list_combine : ('a -> 'b -> 'c) -> 'a list -> 'b list -> 'c list
type ident = positive
val id_eq : positive -> positive -> sumbool
type term = Fun of ident * term list | Var of ident | State of ident
val term_rect' :
  (ident -> 'a) ->
  (ident -> 'a) ->
  (ident -> term list -> 'b -> 'a) ->
  'b -> (term -> term list -> 'a -> 'b -> 'b) -> term -> 'a
val term_eq_dec : term -> term -> sumbool
type l_rule = Lrule of term * term
type l_rules = l_rule list
type substitution = ident -> term option
val add_subst :
  (positive -> term option) ->
  positive -> term -> (positive -> term option) option
val subst : (ident -> term option) -> term -> term
module type TREE =
  sig
    type elt
    val elt_eq : elt -> elt -> sumbool
    type 'a t
    val eq : ('a -> 'a -> sumbool) -> 'a t -> 'a t -> sumbool
    val empty : 'a t
    val get : elt -> 'a t -> 'a option
    val set : elt -> 'a -> 'a t -> 'a t
    val remove : elt -> 'a t -> 'a t
    val is_empty : 'a t -> sumbool
    val map : (elt -> 'a -> 'b) -> 'a t -> 'b t
    val mapi : (elt -> 'a -> 'b option) -> 'a t -> 'b t
    val combine :
      ('a option -> 'a option -> 'a option) -> 'a t -> 'a t -> 'a t
    val elements : 'a t -> (elt, 'a) prod list
    val fold : ('a -> elt -> 'b -> 'a) -> 'b t -> 'a -> 'a
    val left : elt -> elt
    val right : elt -> elt
    val join : 'a t -> 'a t -> 'a t
  end
module PTree :
  sig
    type elt = positive
    val elt_eq : positive -> positive -> sumbool
    type 'a tree = Leaf | Node of 'a tree * 'a option * 'a tree
    val tree_rect :
      'a ->
      ('b tree -> 'a -> 'b option -> 'b tree -> 'a -> 'a) -> 'b tree -> 'a
    val tree_rec :
      'a ->
      ('b tree -> 'a -> 'b option -> 'b tree -> 'a -> 'a) -> 'b tree -> 'a
    type 'a t = 'a tree
    val eq : ('a -> 'b -> sumbool) -> 'a tree -> 'b tree -> sumbool
    val empty : 'a tree
    val is_empty : 'a tree -> sumbool
    val get : positive -> 'a tree -> 'a option
    val set : positive -> 'a -> 'a tree -> 'a tree
    val remove : positive -> 'a tree -> 'a tree
    val append : positive -> positive -> positive
    val xmap : (positive -> 'a -> 'b) -> 'a tree -> positive -> 'b tree
    val map : (positive -> 'a -> 'b) -> 'a tree -> 'b tree
    val xmapi :
      (positive -> 'a -> 'b option) -> 'a tree -> positive -> 'b tree
    val mapi : (positive -> 'a -> 'b option) -> 'a tree -> 'b tree
    val xcombine_l :
      ('a option -> 'b option -> 'c option) -> 'a tree -> 'c tree
    val xcombine_r :
      ('a option -> 'b option -> 'c option) -> 'b tree -> 'c tree
    val combine :
      ('a option -> 'b option -> 'c option) -> 'a tree -> 'b tree -> 'c tree
    val xelements : 'a tree -> positive -> (positive, 'a) prod list
    val elements : 'a tree -> (positive, 'a) prod list
    val xget : positive -> positive -> 'a tree -> 'a option
    val xkeys : 'a tree -> positive -> positive list
    val fold : ('a -> positive -> 'b -> 'a) -> 'b tree -> 'a -> 'a
    val left : positive -> positive
    val right : positive -> positive
    val join : 'a tree -> 'a tree -> 'a tree
  end
module type SET_LIST =
  sig
    type coq_A
    type t
    val empty : t
    val inl : coq_A list -> t -> sumbool
    val is_empty : t -> sumbool
    val lists : t -> coq_A list list
    val add : coq_A list -> t -> t
    val merge : t -> t -> t
    val prod : (coq_A -> coq_A -> coq_A) -> t -> t -> t
    val fold : ('a -> coq_A list -> 'a) -> t -> 'a -> 'a
    val map : (coq_A -> coq_A) -> t -> t
    val filter : (coq_A list -> bool) -> t -> t
  end
module type KEY = sig type coq_A val eq : coq_A -> coq_A -> sumbool end
module type STATE = KEY
module State :
  sig type coq_A = positive val eq : positive -> positive -> sumbool end
module MakeSetList :
  functor (St : STATE) ->
    sig
      type coq_A = St.coq_A
      val eqdec : St.coq_A -> St.coq_A -> sumbool
      type t = coq_A list list
      val empty : 'a list
      val list_eqdec : St.coq_A list -> St.coq_A list -> sumbool
      val inl : St.coq_A list -> St.coq_A list list -> sumbool
      val is_empty : 'a list -> sumbool
      val lists : 'a -> 'a
      val add : 'a -> 'a list -> 'a list
      val merge :
        St.coq_A list list -> St.coq_A list list -> St.coq_A list list
      val prod :
        ('a -> 'b -> 'c) -> 'a list list -> 'b list list -> 'c list list
      val fold : ('a -> 'b -> 'a) -> 'b list -> 'a -> 'a
      val map : ('a -> 'b) -> 'a list list -> 'b list list
      val filter : ('a -> bool) -> 'a list -> 'a list
    end
module Make :
  functor
    (Tree : sig
              type elt = positive
              val elt_eq : elt -> elt -> sumbool
              type 'a t
              val eq : ('a -> 'a -> sumbool) -> 'a t -> 'a t -> sumbool
              val empty : 'a t
              val get : elt -> 'a t -> 'a option
              val set : elt -> 'a -> 'a t -> 'a t
              val remove : elt -> 'a t -> 'a t
              val is_empty : 'a t -> sumbool
              val map : (elt -> 'a -> 'b) -> 'a t -> 'b t
              val mapi : (elt -> 'a -> 'b option) -> 'a t -> 'b t
              val combine :
                ('a option -> 'a option -> 'a option) -> 'a t -> 'a t -> 'a t
              val elements : 'a t -> (elt, 'a) prod list
              val fold : ('a -> elt -> 'b -> 'a) -> 'b t -> 'a -> 'a
              val left : elt -> elt
              val right : elt -> elt
              val join : 'a t -> 'a t -> 'a t
            end) ->
    functor
      (SetList : sig
                   type coq_A = positive
                   type t
                   val empty : t
                   val inl : coq_A list -> t -> sumbool
                   val is_empty : t -> sumbool
                   val lists : t -> coq_A list list
                   val add : coq_A list -> t -> t
                   val merge : t -> t -> t
                   val prod : (coq_A -> coq_A -> coq_A) -> t -> t -> t
                   val fold : ('a -> coq_A list -> 'a) -> t -> 'a -> 'a
                   val map : (coq_A -> coq_A) -> t -> t
                   val filter : (coq_A list -> bool) -> t -> t
                 end) ->
      sig
        type t = SetList.t Tree.t Tree.t
        val empty : 'a Tree.t
        val get0 : Tree.elt -> 'a Tree.t Tree.t -> 'a Tree.t
        val get1 : Tree.elt -> SetList.t Tree.t -> SetList.t
        val get :
          Tree.elt -> Tree.elt -> SetList.t Tree.t Tree.t -> SetList.t
        val symbol_list : Tree.elt -> 'a Tree.t Tree.t -> Tree.elt list
        val dom : 'a Tree.t -> Tree.elt list
        val add :
          Tree.elt ->
          Tree.elt ->
          SetList.coq_A list ->
          SetList.t Tree.t Tree.t -> SetList.t Tree.t Tree.t
        val map :
          (SetList.coq_A -> SetList.coq_A) ->
          SetList.t Tree.t Tree.t -> SetList.t Tree.t Tree.t
        val st_forall : (Tree.elt -> bool) -> 'a Tree.t -> bool
        val fold :
          ('a -> Tree.elt -> Tree.elt -> SetList.coq_A list -> 'a) ->
          SetList.t Tree.t Tree.t -> 'a -> 'a
        val left : Tree.elt -> Tree.elt
        val right : Tree.elt -> Tree.elt
        val join :
          SetList.t Tree.t Tree.t ->
          SetList.t Tree.t Tree.t -> SetList.t Tree.t Tree.t
      end
module SetList :
  sig
    type coq_A = State.coq_A
    val eqdec : State.coq_A -> State.coq_A -> sumbool
    type t = coq_A list list
    val empty : 'a list
    val list_eqdec : State.coq_A list -> State.coq_A list -> sumbool
    val inl : State.coq_A list -> State.coq_A list list -> sumbool
    val is_empty : 'a list -> sumbool
    val lists : 'a -> 'a
    val add : 'a -> 'a list -> 'a list
    val merge :
      State.coq_A list list -> State.coq_A list list -> State.coq_A list list
    val prod :
      ('a -> 'b -> 'c) -> 'a list list -> 'b list list -> 'c list list
    val fold : ('a -> 'b -> 'a) -> 'b list -> 'a -> 'a
    val map : ('a -> 'b) -> 'a list list -> 'b list list
    val filter : ('a -> bool) -> 'a list -> 'a list
  end
module Delta :
  sig
    type t = SetList.t PTree.t PTree.t
    val empty : 'a PTree.t
    val get0 : PTree.elt -> 'a PTree.t PTree.t -> 'a PTree.t
    val get1 : PTree.elt -> SetList.t PTree.t -> SetList.t
    val get :
      PTree.elt -> PTree.elt -> SetList.t PTree.t PTree.t -> SetList.t
    val symbol_list : PTree.elt -> 'a PTree.t PTree.t -> PTree.elt list
    val dom : 'a PTree.t -> PTree.elt list
    val add :
      PTree.elt ->
      PTree.elt ->
      SetList.coq_A list ->
      SetList.t PTree.t PTree.t -> SetList.t PTree.t PTree.t
    val map :
      (SetList.coq_A -> SetList.coq_A) ->
      SetList.t PTree.t PTree.t -> SetList.t PTree.t PTree.t
    val st_forall : (PTree.elt -> bool) -> 'a PTree.t -> bool
    val fold :
      ('a -> PTree.elt -> PTree.elt -> SetList.coq_A list -> 'a) ->
      SetList.t PTree.t PTree.t -> 'a -> 'a
    val left : PTree.elt -> PTree.elt
    val right : PTree.elt -> PTree.elt
    val join :
      SetList.t PTree.t PTree.t ->
      SetList.t PTree.t PTree.t -> SetList.t PTree.t PTree.t
  end
type state = positive
type automaton = { qf : state list; d : Delta.t; }
val qf : automaton -> state list
val d : automaton -> Delta.t
val match_conf : SetList.t PTree.t PTree.t -> PTree.elt -> term -> bool
type env = (state, state) prod list
val states_dec :
  (positive, positive) prod -> (positive, positive) prod -> sumbool
val add_list_1 :
  ('a, 'b) prod list -> 'a list -> 'b list -> ('a, 'b) prod list
val full_set : 'a list -> 'b list -> ('a, 'b) prod list
val del :
  (positive, positive) prod list ->
  (positive, positive) prod -> (positive, positive) prod list
val suppr :
  (positive, positive) prod list ->
  (positive, positive) prod list -> (positive, positive) prod list
val mu :
  positive list -> positive list -> (positive, positive) prod list -> nat
val mu0 : 'a PTree.t -> 'b PTree.t -> (positive, positive) prod list -> nat
val mu_defined :
  'a PTree.t -> 'b PTree.t -> (positive, positive) prod list -> nat
val all_nil_or_not' : SetList.t PTree.t PTree.t -> PTree.elt -> sumbool
val istate_dec :
  SetList.t PTree.t PTree.t ->
  SetList.t PTree.t PTree.t ->
  (PTree.elt, PTree.elt) prod list -> PTree.elt -> PTree.elt -> sumbool
val inclusion_dec : automaton -> automaton -> bool
type substitutions = substitution list
val matching_rec :
  SetList.t PTree.t PTree.t ->
  (ident -> term option) list ->
  term -> PTree.elt -> (ident -> term option) list
val matching :
  SetList.t PTree.t PTree.t ->
  PTree.elt -> term -> (ident -> term option) list
type substitutions0 = substitution list
type state0 = positive
val all_reduce :
  SetList.t PTree.t PTree.t ->
  PTree.elt -> term -> (ident -> term option) list -> bool
val list_eq : positive list -> positive list -> bool
val confs_red :
  SetList.t PTree.t PTree.t ->
  PTree.elt -> 'a -> ('a -> term option) list -> bool
val closure_at_q :
  SetList.t PTree.t PTree.t -> PTree.elt -> term -> term -> bool
val closure_rule : SetList.t PTree.t PTree.t -> term -> term -> bool
val closure_at_q' :
  SetList.t PTree.t PTree.t -> PTree.elt -> term -> ident -> bool
val closure_rule' : SetList.t PTree.t PTree.t -> term -> ident -> bool
val closure_by_llrule : SetList.t PTree.t PTree.t -> term -> term -> bool
val closure_by_l_rules : SetList.t PTree.t PTree.t -> l_rule list -> bool
val postFix : automaton -> automaton -> l_rule list -> bool
