open Ast
open Lexing

let okCode = 0
let koCode = 1
let lexCode = 2
let synCode = 2
let objCode = 3
let sysCode = 4



let localisation file stPos endPos=
  let l = stPos.pos_lnum in
  let c = stPos.pos_cnum - stPos.pos_bol in
  let d = endPos.pos_cnum - endPos.pos_bol in
    Format.eprintf "File \"%s\", line %d, characters %d-%d:\n"
      file l c d

let warn loc msg = 
  Format.eprintf
    "File \"%s\", line %i, characters %i-%i:\nWarning: %s\n@?"
    loc.file loc.line loc.st_pos loc.end_pos msg

let error n loc msg =
  Format.eprintf
    "File \"%s\", line %i, characters %i-%i:\nError: %s\n@?"
    loc.file loc.line loc.st_pos loc.end_pos msg;
  exit n

  
    
